SLASH_GC1 = "/GearCheck";
SLASH_GC2 = "/gc";
GearCheckVersion = "GearCheck v0.6";
GearCheckDBavg = {};
GearCheckDBevg = {};

--begin localization
local L = {};
L["request"] = "Requesting GearCheck of";
L["request2"] = "";
L["requestinformation"] = "This only works, if your target is also running this AddOn";
L["current equip"] = " (current equip)";
L["blizz"] = " (Blizzard-Calculation)";
L["requestGC"] = "Perform GearCheck";
L["Report-Options:"]="Report-Options:";
L["ChatFrame1"]="ChatFrame1";
L["/say"]="/say";
L["/yell"]="/yell";
L["/party"]="/party";
L["/raid"]="/raid";
L["/guild"]="/guild";
L["/whisper:"]="/whisper:";
L["General-Options:"]="General-Options:";
L["lockFrames"]="Lock Frames";
L["enableMinimapButton"]="Enable Minimap-Button";
L["lockMinimapButton"]="Lock Minimap-Button";
L["Respond"] = "Respond to GC-Requests";
L["requestRaid"] = "Requesting Group- / Raid-GearCheack";
L["requestinformation2"] = "This only works, for party- / raid-members that are also running this AddOn";
L["noResponse"] = " doesn't respond to GearCheck-Request";
if (GetLocale() == "deDE") then
	L["request"] = "GearCheck von";
	L["request2"] = "wird angefordert";
	L["requestinformation"] = "Dies funktioniert nur, wenn die Zielperson ebenfalls dieses AddOn verwendet";
	L["current equip"] = " (momentane Ausr\195\188stung)"
	L["blizz"] = " (Blizzard-Berechnung)";
	L["requestGC"] = "GearCheck durchf\195\188hren";
	L["Report-Options:"]="Bericht-Optionen:";
	L["ChatFrame1"]="ChatFrame1";
	L["/say"]="/sagen";
	L["/yell"]="/schreien";
	L["/party"]="/gruppe";
	L["/raid"]="/schlachtzug";
	L["/guild"]="/gilde";
	L["/whisper:"]="/fl\195\188stern:";
	L["General-Options:"]="Allgemeine Optionen:";
	L["lockFrames"]="Fenster sperren";
	L["enableMinimapButton"]="Minimap anzeigen";
	L["lockMinimapButton"]="Minimap sperren";
	L["Respond"] = "GC-Anfragen beantworten";
	L["requestRaid"] = "Gruppen- / Raid-GearCheck wird angefordert";
	L["requestinformation2"] = "Dies funktioniert nur, bei den Gruppen- /Raid-Mitgliedern, die dieses AddOn verwenden";
	L["noResponse"] = " beantwortet GearCheck-Anfragen nicht";
else
end
--end localization

function GearCheckRound(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

function GearCheckGetCurrentAverageItemLevel()
	local avgItemLevel = 0;
	local j = 16;
	for i=1, 3 do
		local itemID = GetInventoryItemID("player", i);
		if (not (itemID == nil)) then		
			local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
			avgItemLevel = avgItemLevel + itemLevel;				
		end
	end
	for i=5, 15 do
		local itemID = GetInventoryItemID("player", i);
		if (not (itemID == nil)) then		
			local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
			avgItemLevel = avgItemLevel + itemLevel;				
		end
	end
	local itemID = GetInventoryItemID("player", 16);
	if (not (itemID == nil)) then		
		local _, _, _, itemLevel, _, itemType, _, _, _, _, _= GetItemInfo(itemID);
		avgItemLevel = avgItemLevel + itemLevel;
		if (itemType == "One-Hand") then
			itemID = GetInventoryItemID("player", 17);
			if (not (itemID == nil)) then		
				local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
				avgItemLevel = avgItemLevel + itemLevel;
			end
			j = j + 1;
		elseif (itemType == "Two-Hand") then
			itemID = GetInventoryItemID("player", 17);
			if (not (itemID == nil)) then		
				local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
				avgItemLevel = avgItemLevel + itemLevel;
				j = j + 1;
			end			
		end
	else
		itemID = GetInventoryItemID("player", 17);
		if (not (itemID == nil)) then		
			local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
			avgItemLevel = avgItemLevel + itemLevel;
		end
		j = j + 1;
	end
	itemID = GetInventoryItemID("player", 18);
	if (not (itemID == nil)) then		
		local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
		avgItemLevel = avgItemLevel + itemLevel;
	end
	avgItemLevel = avgItemLevel / j;
	return avgItemLevel;
end

function GearCheckRespond(target)
	if GearCheck_Respond then		
		SendAddonMessage("GearCheck", "+"..GearCheckRound(GetAverageItemLevel(), 0), "WHISPER", target);
		SendAddonMessage("GearCheck", "*"..GearCheckRound(GearCheckGetCurrentAverageItemLevel(), 0), "WHISPER", target);
	else		
		SendAddonMessage("GearCheck", "-", "WHISPER", target);
	end
end

function GearCheckRequest(target)
	GearCheckReport(L["request"].." "..target.." "..L["request2"]);
	GearCheckReport(L["requestinformation"]);
	SendAddonMessage("GearCheck", "?", "WHISPER", target);
end

function GearCheckRequest2()
	GearCheckReport(L["requestRaid"]);
	GearCheckReport(L["requestinformation2"]);
	SendAddonMessage("GearCheck", "?", "RAID");
end

function GearCheckReport(message)
	if GearCheckReportTo["ChatFrame1"] then
		print(message);
	end
	if GearCheckReportTo["Say"] then
		SendChatMessage(message, "SAY");
	end
	if GearCheckReportTo["Yell"] then
		SendChatMessage(message, "YELL");
	end
	if GearCheckReportTo["Party"] then
		SendChatMessage(message, "PARTY");
	end
	if GearCheckReportTo["Raid"] then
		SendChatMessage(message, "RAID");
	end
	if GearCheckReportTo["Guild"] then
		SendChatMessage(message, "GUILD");
	end
	if GearCheckReportTo["Whisper"] then
		local h = GearCheckOptionsWhisperBox:GetText();
		if (not (h == nil)) then
			SendChatMessage(message, "WHISPER", nil, h);
		end
	end
end

SlashCmdList["GC"] = function(args)
	local s, e = string.find(args, " ");
	if ((s == nil) and (e == nil)) then
	else
		local arg1 = string.sub(args, 0, e-1);
		local arg2 = string.sub(args, e+1);
		if (arg1 == "request") then
			GearCheckRequest(arg2);
		end
	end
end

function GearCheckOnEvent(event, arg1, arg2, arg3, arg4)	
	if event == "CHAT_MSG_ADDON" and arg1 == "GearCheck" then
		--print(arg1.." "..arg2.." "..arg3.." "..arg4);
		--[[
		arg1=prefix 
		arg2=message 
		arg3=distribution type ("PARTY", "RAID", "GUILD", "BATTLEGROUND" or "WHISPER") 
		arg4=sender
		]]--	
		if (string.len(arg2) == 1) then
			if (arg2 == "?") then
				GearCheckRespond(arg4);
			elseif (arg2 == "-") then
				GearCheckReport(arg4..L["noResponse"]);
			end
		elseif (string.len(arg2) > 1) then
			local _, e1 = string.find(arg2, "+");
			if (not (e1 == nil)) then
				local avgItemLevel = string.sub(arg2, e1+1);
				GearCheckDBavg[arg4] = avgItemLevel;
				GearCheckReport(arg4..": "..avgItemLevel..L["blizz"]);
			end
			local _, e2 = string.find(arg2, "*");
			if (not (e2 == nil)) then
				local eavgItemLevel = string.sub(arg2, e2+1);
				GearCheckDBevg[arg4] = eavgItemLevel;
				GearCheckReport(arg4..": "..eavgItemLevel..L["current equip"]);
			end
		end
	elseif event == "ADDON_LOADED" and arg1 == "GearCheck" then
		if GearCheckReportTo == nil then
			GearCheckReportTo = {};
			GearCheckReportTo["ChatFrame1"]=true;
			GearCheckReportTo["Say"]=false;
			GearCheckReportTo["Yell"]=false;
			GearCheckReportTo["Party"]=false;
			GearCheckReportTo["Raid"]=false;
			GearCheckReportTo["Guild"]=false;
			GearCheckReportTo["Whisper"]=false;
		end
		if GearCheck_LockFrames == nil then
			GearCheck_LockFrames = false;
		end
		if GearCheck_Respond == nil then
			GearCheck_Respond = true;
		end
		if GearCheck_LockMinimapButton == nil then
			GearCheck_LockMinimapButton = false;
		end
		if GearCheck_FramePosition == nil then
			GearCheck_FramePosition = {};
			GearCheck_FramePosition["point"] = "CENTER";
			GearCheck_FramePosition["x"] = 0;
			GearCheck_FramePosition["y"] = 0;
		end
		if GearCheck_MinimapButtonPosition == nil then
			GearCheck_MinimapButtonPosition = {};
			GearCheck_MinimapButtonPosition["point"] = "TOP";
			GearCheck_MinimapButtonPosition["x"] = 0;
			GearCheck_MinimapButtonPosition["y"] = 0;
		end
		if GearCheck_EnableMinimapButton == nil then
			GearCheck_EnableMinimapButton = true;
		end
		if GearCheck_LockShowLootFrame == nil then
			GearCheck_LockShowLootFrame = false;
		end	
				
		GearCheckOptionsCheckButtonChatFrame:SetChecked(GearCheckReportTo["ChatFrame1"]);
		GearCheckOptionsCheckButtonSay:SetChecked(GearCheckReportTo["Say"]);
		GearCheckOptionsCheckButtonYell:SetChecked(GearCheckReportTo["Yell"]);
		GearCheckOptionsCheckButtonParty:SetChecked(GearCheckReportTo["Party"]);
		GearCheckOptionsCheckButtonRaid:SetChecked(GearCheckReportTo["Raid"]);
		GearCheckOptionsCheckButtonGuild:SetChecked(GearCheckReportTo["Guild"]);
		GearCheckOptionsCheckButtonWhisper:SetChecked(GearCheckReportTo["Whisper"]);
		
		GearCheckOptionsCheckButtonRespond:SetChecked(GearCheck_Respond);
		GearCheckOptionsCheckButtonLockFrames:SetChecked(GearCheck_LockFrames);
		GearCheckOptionsCheckButtonEnableMinimapButton:SetChecked(GearCheck_EnableMinimapButton);
		GearCheckOptionsCheckButtonLockMinimapButton:SetChecked(GearCheck_LockMinimapButton);		
		
		GearCheckFrame:SetPoint(GearCheck_FramePosition["point"], GearCheck_FramePosition["x"], GearCheck_FramePosition["y"]);
		
		if not GearCheck_LockFrames then		
			GearCheckFrame:RegisterForDrag("LeftButton");			
		end
				
		GearCheckMinimapButton:SetPoint(GearCheck_MinimapButtonPosition["point"], Minimap, GearCheck_MinimapButtonPosition["x"], GearCheck_MinimapButtonPosition["y"]);
		if GearCheck_EnableMinimapButton then
			GearCheckMinimapButton:Show();
		else
			GearCheckMinimapButton:Hide();
		end	
		if not GearCheck_LockMinimapButton then		
			GearCheckMinimapButton:RegisterForDrag("LeftButton");			
		end		
	end
end

UnitPopupButtons["GearCheck"]={text = "|cffff0000GearCheck|r", dist = 0};
tinsert(UnitPopupMenus["FRIEND"], 1, "GearCheck");
tinsert(UnitPopupMenus["RAID_PLAYER"], 1, "GearCheck");
tinsert(UnitPopupMenus["PARTY"], 1, "GearCheck");
hooksecurefunc("UnitPopup_OnClick", function(this)
	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU
	local button = this.value
	local name = dropdownFrame.name;
	if button == "GearCheck" then	
		GearCheckRequest(name);
	end
end)

GearCheckMinimapButton = CreateFrame("BUTTON", "GearCheckMinimapButton", Minimap);
GearCheckMinimapButton:SetWidth(31);
GearCheckMinimapButton:SetHeight(31);
GearCheckMinimapButton:SetFrameStrata("LOW");
GearCheckMinimapButton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
GearCheckMinimapButton:SetPoint("RIGHT", Minimap, "LEFT");
GearCheckMinimapButtonIcon = GearCheckMinimapButton:CreateTexture(nil, "BACKGROUND");
GearCheckMinimapButtonIcon:SetTexture("Interface\\AddOns\\GearCheck\\GearCheckIcon");
GearCheckMinimapButtonIcon:SetPoint("TOPLEFT", 6, -6);
GearCheckMinimapButtonIcon:SetPoint("BOTTOMRIGHT", -6, 6);
GearCheckMinimapButtonOverlay = GearCheckMinimapButton:CreateTexture(nil, "OVERLAY");
GearCheckMinimapButtonOverlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
GearCheckMinimapButtonOverlay:SetWidth(53);
GearCheckMinimapButtonOverlay:SetHeight(53);
GearCheckMinimapButtonOverlay:SetPoint("TOPLEFT");
GearCheckMinimapButton:SetMovable(true);
GearCheckMinimapButton:EnableMouse(true);
GearCheckMinimapButton:SetScript("OnDragStart", function() GearCheckMinimapButton:StartMoving() end);
GearCheckMinimapButton:SetScript("OnDragStop", function()
													GearCheckMinimapButton:StopMovingOrSizing();
													local point, relativeTo, relativePoint, x, y = GearCheckMinimapButton:GetPoint();
													GearCheck_MinimapButtonPosition["point"] = point;													
													GearCheck_MinimapButtonPosition["x"] = x;
													GearCheck_MinimapButtonPosition["y"] = y;
												 end);
GearCheckMinimapButton:SetScript("OnClick", function()
												if GearCheckFrame:IsShown() then
													GearCheckFrame:Hide();
													GearCheckOptionsFrame:Hide();
												elseif not GearCheckFrame:IsShown() then
													GearCheckFrame:Show();
												end												
											end);										
GearCheckMinimapButton:Hide();

GearCheckFrame, events = CreateFrame("FRAME", "GearCheckFrame", UIParent);
GearCheckFrame:SetWidth(200);
GearCheckFrame:SetHeight(75);
GearCheckFrame:RegisterEvent("ADDON_LOADED");
GearCheckFrame:RegisterEvent("CHAT_MSG_ADDON");
GearCheckFrame:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4, ...)
										GearCheckOnEvent(event, arg1, arg2, arg3, arg4);
										end);
GearCheckFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckFrame:EnableMouse(true);
GearCheckFrame:SetMovable(true);
GearCheckFrame:SetUserPlaced(true);
GearCheckFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
GearCheckFrame:SetScript("OnDragStop", function()
											GearCheckFrame:StopMovingOrSizing();
											local point, relativeTo, relativePoint, x, y = GearCheckFrame:GetPoint();
											GearCheck_FramePosition["point"] = point;													
											GearCheck_FramePosition["x"] = x;
											GearCheck_FramePosition["y"] = y;
										  end);
GearCheckFrame:Hide();
tinsert(UISpecialFrames, GearCheckFrame:GetName());

local GearCheckTopFrame = CreateFrame("FRAME", nil, GearCheckFrame);
GearCheckTopFrame:SetWidth(120);
GearCheckTopFrame:SetHeight(25);
GearCheckTopFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckTopFrame:SetPoint("TOP", 0, 10);
GearCheckTopFrame:Show();

local GearCheckFrameText = GearCheckTopFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameText:SetTextColor(1, 0, 0, 1.0);
GearCheckFrameText:SetText(GearCheckVersion);
GearCheckFrameText:SetPoint("CENTER");

local GearCheckFrameOptions = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameOptions:SetWidth(15);
GearCheckFrameOptions:SetHeight(15);
GearCheckFrameOptions:SetText("O");
GearCheckFrameOptions:SetPoint("TOPLEFT", 5, -5);
GearCheckFrameOptions:SetScript("OnClick", function()
												if GearCheckOptionsFrame:IsShown() then
													GearCheckOptionsFrame:Hide();													
												elseif not GearCheckOptionsFrame:IsShown() then
													GearCheckOptionsFrame:Show();
												end											
											 end);
GearCheckFrameOptions:SetAlpha(1);
GearCheckFrameOptions:Show();

local GearCheckFrameClose = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameClose:SetWidth(15);
GearCheckFrameClose:SetHeight(15);
GearCheckFrameClose:SetText("X");
GearCheckFrameClose:SetPoint("TOPRIGHT", -5, -5);
GearCheckFrameClose:SetScript("OnClick", function()
											GearCheckFrame:Hide();
											GearCheckOptionsFrame:Hide();
										   end);
GearCheckFrameClose:SetAlpha(1);
GearCheckFrameClose:Show();

local GearCheckFrameRequestButton = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameRequestButton:SetWidth(180);
GearCheckFrameRequestButton:SetHeight(20);
GearCheckFrameRequestButton:SetText(L["requestGC"]);
GearCheckFrameRequestButton:SetPoint("TOP", 0, -20);
GearCheckFrameRequestButton:SetScript("OnClick", function()
													local arg = GearCheckRequestBox:GetText();
													if string.len(arg) == 0 then
														GearCheckRequest2();
													else
														GearCheckRequest(arg);
													end
												end);
GearCheckFrameRequestButton:SetAlpha(1);
GearCheckFrameRequestButton:Show();

local GearCheckRequestBox = CreateFrame("EDITBOX", "GearCheckRequestBox", GearCheckFrame, "InputBoxTemplate")
GearCheckRequestBox:SetWidth(163);
GearCheckRequestBox:SetHeight(15);
GearCheckRequestBox:SetPoint("TOP", GearCheckFrameRequestButton, "BOTTOM", 2, -5);
GearCheckRequestBox:SetScript("OnTabPressed", function()
													local n, r = UnitName("target");
													if not (n == nil) then
														GearCheckRequestBox:SetText(n);
													end
												end);
GearCheckRequestBox:SetAutoFocus(false);
GearCheckRequestBox:Show();

local GearCheckOptionsFrame = CreateFrame("FRAME", "GearCheckOptionsFrame", UIParent);
GearCheckOptionsFrame:SetWidth(200);
GearCheckOptionsFrame:SetHeight(250);
GearCheckOptionsFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckOptionsFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckOptionsFrame:SetPoint("TOP", GearCheckFrame, "BOTTOM", 0, 0);
tinsert(UISpecialFrames, GearCheckOptionsFrame:GetName());
GearCheckOptionsFrame:Hide();

local GearCheckOptionsText2 = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsText2:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckOptionsText2:SetWidth(175);
GearCheckOptionsText2:SetJustifyH("LEFT");
GearCheckOptionsText2:SetText(L["Report-Options:"]);
GearCheckOptionsText2:SetPoint("TOPLEFT", 5, -10);

local GearCheckOptionsChatFrame = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsChatFrame:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsChatFrame:SetWidth(175);
GearCheckOptionsChatFrame:SetHeight(15);
GearCheckOptionsChatFrame:SetJustifyH("LEFT");
GearCheckOptionsChatFrame:SetText(L["ChatFrame1"]);
GearCheckOptionsChatFrame:SetPoint("TOP", GearCheckOptionsText2, "BOTTOM", 25, -5);

GearCheckOptionsCheckButtonChatFrame = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonChatFrame:SetWidth(15);
GearCheckOptionsCheckButtonChatFrame:SetHeight(15);
GearCheckOptionsCheckButtonChatFrame:SetPoint("RIGHT", GearCheckOptionsChatFrame, "LEFT", -5, 0);
GearCheckOptionsCheckButtonChatFrame:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonChatFrame:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonChatFrame:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonChatFrame:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonChatFrame:SetScript("OnClick", function() GearCheckReportTo["ChatFrame1"] = tobool(GearCheckOptionsCheckButtonChatFrame:GetChecked()); end);
GearCheckOptionsCheckButtonChatFrame:Show();

local GearCheckOptionsSay = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsSay:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsSay:SetWidth(175);
GearCheckOptionsSay:SetHeight(15);
GearCheckOptionsSay:SetJustifyH("LEFT");
GearCheckOptionsSay:SetText(L["/say"]);
GearCheckOptionsSay:SetPoint("TOP", GearCheckOptionsChatFrame, "BOTTOM", 0, 0);

GearCheckOptionsCheckButtonSay = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonSay:SetWidth(15);
GearCheckOptionsCheckButtonSay:SetHeight(15);
GearCheckOptionsCheckButtonSay:SetPoint("RIGHT", GearCheckOptionsSay, "LEFT", -5, 0);
GearCheckOptionsCheckButtonSay:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonSay:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonSay:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonSay:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonSay:SetScript("OnClick", function() GearCheckReportTo["Say"] = tobool(GearCheckOptionsCheckButtonSay:GetChecked()); end);
GearCheckOptionsCheckButtonSay:Show();

local GearCheckOptionsYell = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsYell:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsYell:SetWidth(175);
GearCheckOptionsYell:SetHeight(15);
GearCheckOptionsYell:SetJustifyH("LEFT");
GearCheckOptionsYell:SetText(L["/yell"]);
GearCheckOptionsYell:SetPoint("TOP", GearCheckOptionsSay, "BOTTOM", 0, 0);

GearCheckOptionsCheckButtonYell = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonYell:SetWidth(15);
GearCheckOptionsCheckButtonYell:SetHeight(15);
GearCheckOptionsCheckButtonYell:SetPoint("RIGHT", GearCheckOptionsYell, "LEFT", -5, 0);
GearCheckOptionsCheckButtonYell:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonYell:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonYell:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonYell:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonYell:SetScript("OnClick", function() GearCheckReportTo["Yell"] = tobool(GearCheckOptionsCheckButtonYell:GetChecked()); end);
GearCheckOptionsCheckButtonYell:Show();

local GearCheckOptionsParty = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsParty:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsParty:SetWidth(175);
GearCheckOptionsParty:SetHeight(15);
GearCheckOptionsParty:SetJustifyH("LEFT");
GearCheckOptionsParty:SetText(L["/party"]);
GearCheckOptionsParty:SetPoint("TOP", GearCheckOptionsYell, "BOTTOM", 0, 0);

GearCheckOptionsCheckButtonParty = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonParty:SetWidth(15);
GearCheckOptionsCheckButtonParty:SetHeight(15);
GearCheckOptionsCheckButtonParty:SetPoint("RIGHT", GearCheckOptionsParty, "LEFT", -5, 0);
GearCheckOptionsCheckButtonParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonParty:SetScript("OnClick", function() GearCheckReportTo["Party"] = tobool(GearCheckOptionsCheckButtonParty:GetChecked()); end);
GearCheckOptionsCheckButtonParty:Show();

local GearCheckOptionsRaidtxt = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsRaidtxt:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsRaidtxt:SetWidth(175);
GearCheckOptionsRaidtxt:SetHeight(15);
GearCheckOptionsRaidtxt:SetJustifyH("LEFT");
GearCheckOptionsRaidtxt:SetText(L["/raid"]);
GearCheckOptionsRaidtxt:SetPoint("TOP", GearCheckOptionsParty, "BOTTOM", 0, 0);

GearCheckOptionsCheckButtonRaid = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonRaid:SetWidth(15);
GearCheckOptionsCheckButtonRaid:SetHeight(15);
GearCheckOptionsCheckButtonRaid:SetPoint("RIGHT", GearCheckOptionsRaidtxt, "LEFT", -5, 0);
GearCheckOptionsCheckButtonRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");	
GearCheckOptionsCheckButtonRaid:SetScript("OnClick", function() GearCheckReportTo["Raid"] = tobool(GearCheckOptionsCheckButtonRaid:GetChecked()); end);
GearCheckOptionsCheckButtonRaid:Show();

local GearCheckOptionsGuild = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsGuild:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsGuild:SetWidth(175);
GearCheckOptionsGuild:SetHeight(15);
GearCheckOptionsGuild:SetJustifyH("LEFT");
GearCheckOptionsGuild:SetText(L["/guild"]);
GearCheckOptionsGuild:SetPoint("TOP", GearCheckOptionsRaidtxt, "BOTTOM", 0, 0);

GearCheckOptionsCheckButtonGuild = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonGuild:SetWidth(15);
GearCheckOptionsCheckButtonGuild:SetHeight(15);
GearCheckOptionsCheckButtonGuild:SetPoint("RIGHT", GearCheckOptionsGuild, "LEFT", -5, 0);
GearCheckOptionsCheckButtonGuild:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonGuild:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonGuild:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonGuild:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonGuild:SetScript("OnClick", function() GearCheckReportTo["Guild"] = tobool(GearCheckOptionsCheckButtonGuild:GetChecked()); end);
GearCheckOptionsCheckButtonGuild:Show();

local GearCheckOptionsWhisper = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsWhisper:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsWhisper:SetWidth(100);
GearCheckOptionsWhisper:SetHeight(15);
GearCheckOptionsWhisper:SetJustifyH("LEFT");
GearCheckOptionsWhisper:SetText(L["/whisper:"]);
GearCheckOptionsWhisper:SetPoint("TOPLEFT", GearCheckOptionsGuild, "BOTTOMLEFT");

GearCheckOptionsCheckButtonWhisper = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonWhisper:SetWidth(15);
GearCheckOptionsCheckButtonWhisper:SetHeight(15);
GearCheckOptionsCheckButtonWhisper:SetPoint("RIGHT", GearCheckOptionsWhisper, "LEFT", -5, 0);
GearCheckOptionsCheckButtonWhisper:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonWhisper:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonWhisper:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonWhisper:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonWhisper:SetScript("OnClick", function() GearCheckReportTo["Whisper"] = tobool(GearCheckOptionsCheckButtonWhisper:GetChecked()); end);
GearCheckOptionsCheckButtonWhisper:Show();

local GearCheckOptionsWhisperBox = CreateFrame("EDITBOX", "GearCheckOptionsWhisperBox", GearCheckOptionsFrame, "InputBoxTemplate")
GearCheckOptionsWhisperBox:SetWidth(90);
GearCheckOptionsWhisperBox:SetHeight(15);
GearCheckOptionsWhisperBox:SetPoint("LEFT", GearCheckOptionsWhisper, "RIGHT", -40, -2);
GearCheckOptionsWhisperBox:SetScript("OnTabPressed", function()
													local n, r = UnitName("target");
														if not (n == nil) then
														GearCheckOptionsWhisperBox:SetText(n);
													end
												end);
GearCheckOptionsWhisperBox:SetAutoFocus(false);
GearCheckOptionsWhisperBox:Show();

local GearCheckOptionsText3 = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsText3:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckOptionsText3:SetWidth(150);
GearCheckOptionsText3:SetJustifyH("LEFT");
GearCheckOptionsText3:SetText(L["General-Options:"]);
GearCheckOptionsText3:SetPoint("TOPLEFT", GearCheckOptionsWhisper, "BOTTOMLEFT", -25, -10);

local GearCheckOptionsRespond = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsRespond:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsRespond:SetWidth(175);
GearCheckOptionsRespond:SetHeight(15);
GearCheckOptionsRespond:SetJustifyH("LEFT");
GearCheckOptionsRespond:SetText(L["Respond"]);
GearCheckOptionsRespond:SetPoint("TOPLEFT", GearCheckOptionsText3, "BOTTOMLEFT", 25, -5);

GearCheckOptionsCheckButtonRespond = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonRespond:SetWidth(15);
GearCheckOptionsCheckButtonRespond:SetHeight(15);
GearCheckOptionsCheckButtonRespond:SetPoint("RIGHT", GearCheckOptionsRespond, "LEFT", -5, 0);
GearCheckOptionsCheckButtonRespond:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonRespond:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonRespond:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonRespond:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonRespond:SetScript("OnClick", function() 
																GearCheck_Respond = tobool(GearCheckOptionsCheckButtonRespond:GetChecked());
																if GearCheckOptionsCheckButtonRespond:GetChecked() then
																	GearCheckFrame:RegisterForDrag("");
																elseif not GearCheckOptionsCheckButtonRespond:GetChecked() then
																	GearCheckFrame:RegisterForDrag("LeftButton");
																end
															 end);
GearCheckOptionsCheckButtonRespond:Show();


local GearCheckOptionsLockFrames = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsLockFrames:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsLockFrames:SetWidth(175);
GearCheckOptionsLockFrames:SetHeight(15);
GearCheckOptionsLockFrames:SetJustifyH("LEFT");
GearCheckOptionsLockFrames:SetText(L["lockFrames"]);
GearCheckOptionsLockFrames:SetPoint("TOPLEFT", GearCheckOptionsRespond, "BOTTOMLEFT", 0, 0);

GearCheckOptionsCheckButtonLockFrames = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonLockFrames:SetWidth(15);
GearCheckOptionsCheckButtonLockFrames:SetHeight(15);
GearCheckOptionsCheckButtonLockFrames:SetPoint("RIGHT", GearCheckOptionsLockFrames, "LEFT", -5, 0);
GearCheckOptionsCheckButtonLockFrames:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonLockFrames:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonLockFrames:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonLockFrames:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonLockFrames:SetScript("OnClick", function() 
																GearCheck_LockFrames = tobool(GearCheckOptionsCheckButtonLockFrames:GetChecked());
																if GearCheckOptionsCheckButtonLockFrames:GetChecked() then
																	GearCheckFrame:RegisterForDrag("");
																elseif not GearCheckOptionsCheckButtonLockFrames:GetChecked() then
																	GearCheckFrame:RegisterForDrag("LeftButton");
																end
															 end);
GearCheckOptionsCheckButtonLockFrames:Show();

local GearCheckOptionsEnableMinimapButton = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsEnableMinimapButton:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsEnableMinimapButton:SetWidth(175);
GearCheckOptionsEnableMinimapButton:SetHeight(15);
GearCheckOptionsEnableMinimapButton:SetJustifyH("LEFT");
GearCheckOptionsEnableMinimapButton:SetText(L["enableMinimapButton"]);
GearCheckOptionsEnableMinimapButton:SetPoint("TOPLEFT", GearCheckOptionsLockFrames, "BOTTOMLEFT", 0, 0);

GearCheckOptionsCheckButtonEnableMinimapButton = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonEnableMinimapButton:SetWidth(15);
GearCheckOptionsCheckButtonEnableMinimapButton:SetHeight(15);
GearCheckOptionsCheckButtonEnableMinimapButton:SetPoint("RIGHT", GearCheckOptionsEnableMinimapButton, "LEFT", -5, 0);
GearCheckOptionsCheckButtonEnableMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonEnableMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonEnableMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonEnableMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonEnableMinimapButton:SetScript("OnClick", function() 
																		GearCheck_EnableMinimapButton = tobool(GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked());
																		if GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			GearCheckMinimapButton:Show();
																		elseif not GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			GearCheckMinimapButton:Hide();
																		end
																	  end);
GearCheckOptionsCheckButtonEnableMinimapButton:Show();

local GearCheckOptionsLockMinimapButton = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsLockMinimapButton:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsLockMinimapButton:SetWidth(175);
GearCheckOptionsLockMinimapButton:SetHeight(15);
GearCheckOptionsLockMinimapButton:SetJustifyH("LEFT");
GearCheckOptionsLockMinimapButton:SetText(L["lockMinimapButton"]);
GearCheckOptionsLockMinimapButton:SetPoint("TOPLEFT", GearCheckOptionsEnableMinimapButton, "BOTTOMLEFT", 0, 0);

GearCheckOptionsCheckButtonLockMinimapButton = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonLockMinimapButton:SetWidth(15);
GearCheckOptionsCheckButtonLockMinimapButton:SetHeight(15);
GearCheckOptionsCheckButtonLockMinimapButton:SetPoint("RIGHT", GearCheckOptionsLockMinimapButton, "LEFT", -5, 0);
GearCheckOptionsCheckButtonLockMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonLockMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonLockMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonLockMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonLockMinimapButton:SetScript("OnClick", function()
																		GearCheck_LockMinimapButton = tobool(GearCheckOptionsCheckButtonLockMinimapButton:GetChecked());
																		if GearCheckOptionsCheckButtonLockMinimapButton:GetChecked() then
																			GearCheckMinimapButton:RegisterForDrag(""); 
																		elseif not GearCheckOptionsCheckButtonLockMinimapButton:GetChecked() then																			
																			GearCheckMinimapButton:RegisterForDrag("LeftButton");
																		end
																	end);
GearCheckOptionsCheckButtonLockMinimapButton:Show();
-- end UI